
//~ Filters: textbox, tree structure, buttons
var rAddFilter, rAddPolicy, rTree, rTreeCh, rButtons, rPopup;

/**
 * Load/Save settings
 **/
function loadSettingsWindow()
{
    ILO_BUNDLE = document.getElementById("imglikeopera-string-bundle");
    
    try {
        var defaultPolicy = ILO_PREF_BRANCH.getIntPref("default.policy");
        var expirationTime = ILO_PREF_BRANCH.getIntPref("expiration.time");
        var tabsRefresh = ILO_PREF_BRANCH.getBoolPref("tabs.refresh");
        var patterns = ILO_PREF_BRANCH.getCharPref("policy.patterns");
    } catch(e) {}
    
    var menuDefaultPolicy = document.getElementById("menu-default-policy");
    menuDefaultPolicy.selectedIndex = 4 - defaultPolicy;
    
    var checkboxExpirationTime = document.getElementById("checkbox-expiration-time");
    var menuExpirationTime = document.getElementById("menu-expiration-time");
    if (expirationTime != 0)
    {
        checkboxExpirationTime.setAttribute("checked", true);
        menuExpirationTime.setAttribute("disabled", false);
        var menuExpirationTimeNodes = menuExpirationTime.childNodes[0].childNodes;
        var menuExpirationTimeNodesCount = menuExpirationTimeNodes.length;
        for (i=0; i<menuExpirationTimeNodesCount; i++)
        {
            if (menuExpirationTimeNodes[i].value == expirationTime)
                menuExpirationTime.selectedIndex = i;
        }
    }
    
    var checkboxTabsRefresh = document.getElementById("checkbox-tabs-refresh");
    checkboxTabsRefresh.setAttribute("checked", tabsRefresh);
    
    rAddFilter = document.getElementById("iloAddFilter");
    rAddPolicy = document.getElementById("iloAddPolicy");
    rTree = document.getElementById("iloPermissionsTree");
    rTreeCh = document.getElementById("iloPermissionsTreeChildren");
    rButtons = document.getElementById("iloPermButtons").childNodes;
    rPopup = document.getElementById("iloFiltersPopup").childNodes;
    
    if (patterns.split)
    {
        var tmp = patterns.split("  ");
        var tmpCount = tmp.length-1;
        for (var i=0; i<tmpCount; i++)
            iloTreeAddItem(tmp[i].split(" "));
    }
    
    var fontInCss = iloReadRulesFromBonusCss();
    
    const fontEnumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"]
                            .createInstance()
                            .QueryInterface(Components.interfaces.nsIFontEnumerator);
    
    var allFonts = fontEnumerator.EnumerateAllFonts({value:0});
    
    var fontMenu = document.getElementById("menu-placeholders-font");
    for (i = 0; i < allFonts.length; i++)
    {
        fontMenu.appendItem(allFonts[i], allFonts[i]);
        if (allFonts[i] == fontInCss[0])
            fontMenu.selectedIndex = i+1;
    }
    
    var sizeMenu = document.getElementById("menu-placeholders-fontsize");
    var sizeMenuNodes = sizeMenu.childNodes[0].childNodes;
    
    for (i = 0; i < sizeMenuNodes.length; i++)
        if (sizeMenuNodes[i].value == fontInCss[1])
            sizeMenu.selectedIndex = i;
    
}

function saveSettings()
{
    var fontFamily = document.getElementById("menu-placeholders-font")
                    .selectedItem.getAttribute("value");
    var fontSize = document.getElementById("menu-placeholders-fontsize")
                    .selectedItem.getAttribute("value");

    iloAddRulesToBonusCss(fontFamily, fontSize);

    var defaultPolicy = 4 - document.getElementById("menu-default-policy").selectedIndex;
    var expirationTime =
        (document.getElementById("checkbox-expiration-time").checked) ?
        document.getElementById("menu-expiration-time").selectedItem.value : 0;
    var tabsRefresh = document.getElementById("checkbox-tabs-refresh").checked;
    
    ILO_PREF_BRANCH.setIntPref("default.policy", defaultPolicy);
    ILO_PREF_BRANCH.setBoolPref("tabs.refresh", tabsRefresh);
    ILO_PREF_BRANCH.setIntPref("expiration.time", expirationTime);
    ILO_PREF_BRANCH.setCharPref("policy.patterns", iloTreeMakePattern());
    
    ILO_OBSERV_SERVICE.notifyObservers(null, "ilo-Load-Settings", false);
    
    window.close();
}

/**
 * Key Events
 **/

function checkEvent(e)
{
    if (e == "quit")
        window.close();
    
    if (document.getElementById("iloSettingsTab2").parentNode.selectedIndex != 1)
        return;
    
    if (e == "copy")
    {
        var rowText = iloGetRowData();
        if (!rowText) return;
        
        rAddFilter.value = rowText[0];
        rAddPolicy.selectedIndex = 4 - rowText[1];
        
        return;
    }
    
    if (e == "modify")
    {
        var rowText = iloGetRowData();
        if (!rowText) return;
        
        var rv = { rv: null };
        
        openDialog("chrome://imglikeopera/content/optionsdialog.xul",
                        "_blank", "chrome,dependent,modal", rowText, rv);
        
        if (rv.rv)
        {
            iloRemoveFilter();
            rowText[2] -= -1;
            iloTreeAddItem(rv.rv, rowText[2]);
        }
        
        return;
    }
    
    if (e == "selectAll")
        return rTree.treeBoxObject.selection.selectAll();
    
    if (e == "removeFilters")
    {
        if (rButtons[4].disabled) return;
        
        if (confirm(ILO_BUNDLE.getString("removeSelectedFilters")+"?"))
            iloRemoveFilter();
        
        return;
    }
    
    if (e == "removeAllFilters")
    {
        if (rButtons[5].disabled) return;
        
        if (confirm(ILO_BUNDLE.getString("removeAllFilters")+"?"))
            iloRemoveFilter("all");
        
        return;
    }
    
    var i = (e == "top" || e == "up") ? 0 : 2;
    if (rButtons[i].getAttribute("disabled") == "true")
        return;
    
    iloFilterSetPriority(e);
}

/**
 * Work with tree
 **/

function iloTreeAddItem(items, indx)
{
    var tri = document.createElement("treeitem");
    var trr = document.createElement("treerow");
    var trc1 = document.createElement("treecell");
    var trc2 = document.createElement("treecell");
    var trc3 = document.createElement("treecell");
    
    //~ RegExp test
    var txt = items[0].replace(/[\s]*/g, "");
    if (txt[0] == "/" && txt[2])
    {
        var mod = "";
        var txtEnd = txt.substr(txt.length-2, txt.length);
        
        if (txtEnd == "/i" || txtEnd == "/I") { mod = "i"; var res = txt.substr(1, txt.length-3); }
        else if (txtEnd[1] == "/") { var res = txt.substr(1, txt.length-2); }
        
        try { var reg = new RegExp(res, mod); } catch(e){}
        
        if (reg)
            trc1.setAttribute("label", "R");
    }
    
    trc2.setAttribute("label", txt);
    trc3.setAttribute("label", items[1]);
    trr.appendChild(trc1);
    trr.appendChild(trc2);
    trr.appendChild(trc3);
    tri.appendChild(trr);
    
    if (!indx)
        return rTreeCh.appendChild(tri);
    
    indx--;
    rTreeCh.insertBefore(tri, rTreeCh.childNodes[indx]);
    rTree.treeBoxObject.selection.select(indx);
}

function iloTreeMakePattern()
{
    var pattern = '', item;
    var iCount = rTreeCh.childNodes.length;
    for (var i = 0; i < iCount; i++)
    {
        item = rTreeCh.childNodes[i].childNodes[0];
        pattern += item.childNodes[1].getAttribute("label") +
                    " " + item.childNodes[2].getAttribute("label") + "  ";
    }
    return pattern;
}

function iloGetTreeSelections()
{
    var selections = [];
    var select = rTree.treeBoxObject.selection;
    if (select) {
        var count = select.getRangeCount();
        var min = new Object();
        var max = new Object();
        for (var i=0; i<count; i++)
        {
            select.getRangeAt(i, min, max);
            for (var k=min.value; k<=max.value; k++) {
                if (k != -1)
                  selections[selections.length] = k;
            }
        }
    }
    return selections;
}

function iloButtonsDisabled(status)
{
    for (var i=0; i<6; i++)
        rButtons[i].setAttribute("disabled", status[i]);
    
    for (i=3; i<7; i++)
        rPopup[i].setAttribute("disabled", status[i-3]);
}

function iloTopBottomButtonStatusTest(selections)
{
    for (var i=selections.length; --i > 0;)
        if (selections[i]-selections[i-1] != 1)
            return "false";
    
    return "true";
}

function iloPermissionSelected()
{
    var selections = iloGetTreeSelections();
    var buttonsStatus = [];
    
    if (selections[0] == 0)
    {
        if (selections.length == 1)
            buttonsStatus.push("true");
        else
            buttonsStatus.push( iloTopBottomButtonStatusTest(selections) );
        
        buttonsStatus.push("true");
    }
    else
    {
        buttonsStatus.push("false","false");
    }
    
    if (selections[selections.length-1]+1 == rTreeCh.childNodes.length)
    {
        buttonsStatus.push("true");
        
        if (selections.length == 1)
            buttonsStatus.push("true");
        else
            buttonsStatus.push( iloTopBottomButtonStatusTest(selections) );
    }
    else
    {
        buttonsStatus.push("false","false");
    }
    
    if (selections.length != 0)
        buttonsStatus.push("false");
    else
        buttonsStatus.push("true");
    
    iloButtonsDisabled(buttonsStatus);
}

function iloRemoveFilter(all)
{
    if (all)
        rTree.treeBoxObject.selection.selectAll();
    
    var selections = iloGetTreeSelections();
        
    for (var s = selections.length-1; s >= 0; s--)
        rTreeCh.removeChild(rTreeCh.childNodes[selections[s]]);
    
    var bAll = rTreeCh.childNodes.length == 0 ? "true" : "false";
    iloButtonsDisabled([ "true","true","true","true","true",bAll ]);
}

function iloFilterSetPriority(prior)
{
    var selections = iloGetTreeSelections();
    var deletedItems = [];
    var i, iCount;
    
    switch (prior)
    {
        case "up":
        
            iCount = selections.length;
            
            for (i = 0; i < iCount; i++)
                rTreeCh.insertBefore(rTreeCh.childNodes[selections[i]],
                                        rTreeCh.childNodes[selections[i]-1]);
            
            break;
        
        case "down":
            
            for (i = selections.length-1; i >= 0; i--)
                rTreeCh.insertBefore(rTreeCh.childNodes[selections[i]],
                                        rTreeCh.childNodes[selections[i]+2]);
            
            break;
        
        case "top":
        
            for (i = selections.length-1; i >= 0; i--)
            {
                deletedItems.push(rTreeCh.childNodes[selections[i]]);
                rTreeCh.removeChild(rTreeCh.childNodes[selections[i]]);
            }
            
            iCount = deletedItems.length;
            
            for (i = 0; i < iCount; i++)
                rTreeCh.insertBefore(deletedItems[i],
                                        rTreeCh.childNodes[0]);
            
            break;
        
        case "bottom":
            
            for (i = selections.length-1; i >= 0; i--)
            {
                deletedItems.push(rTreeCh.childNodes[selections[i]]);
                rTreeCh.removeChild(rTreeCh.childNodes[selections[i]]);
            }
            
            for (i = deletedItems.length-1; i >= 0; i--)
                rTreeCh.appendChild(deletedItems[i]);
            
            break;
        
    }
    
    iloSetTreeSelections(selections, prior);
}

function iloSetTreeSelections(selections, prior)
{
    var select = rTree.treeBoxObject.selection;
    var range;
    
    switch (prior)
    {
        case "up":
            
            for (var s = selections.length-1; s >= 0; s--)
            {
                range = selections[s]-1;
                select.rangedSelect(range, range, true);
            }
            break;
            
        case "down":
            
            for (var s = selections.length-1; s >= 0; s--)
            {
                range = selections[s]+1;
                select.rangedSelect(range, range, true);
            }
            break;
        
        case "top":
            range = selections.length-1;
            select.rangedSelect(0, range, true);
            break;
        
        case "bottom":
            range = rTreeCh.childNodes.length;
            select.rangedSelect(range-selections.length, range-1, true);
            break;
    }
}

/**
 * Patterns adding
 **/

function iloAddFilter()
{
    var filter = rAddFilter.value.replace(/\s*/g, "");
    var policy = 4 - rAddPolicy.selectedIndex;
    
    if (filter == "") return;
    
    var indx = 1 + iloGetTreeSelections()[0];
    if (isNaN(indx)) indx = 1;
    
    iloTreeAddItem([filter, policy], indx);
}

function iloFilterEdit(event, click)
{
    if ((event.button == 0 && click == "dblclick") ||
        (event.button == 2 && click == "rclick"))
    {
        var row = {};
        
        var b = event.originalTarget.parentNode.treeBoxObject;
        b.getCellAt(event.clientX, event.clientY, row, {}, {});
        
        if (row.value == -1)
            return event.originalTarget.removeAttribute("context");
        
        switch (click)
        {
            case "dblclick":
                
                checkEvent("modify");
                break;
                
            case "rclick":
                
                var selections = iloGetTreeSelections();
                
                var disable = selections.length != 1 ? true : false;
                rPopup[0].setAttribute("disabled", disable);
                rPopup[1].setAttribute("disabled", disable);
                
                event.originalTarget.setAttribute("context", "iloFiltersPopup");
                
                break;
        }
    }
}

function iloGetRowData()
{
    //~ get selected tree rows
    var select = iloGetTreeSelections();
    
    //~ alert("Please, give me a single row selection");
    if (select.length != 1) return;
    
    //~ return Array( filter, policy, row index )
    return [rTreeCh.childNodes[select[0]].childNodes[0].childNodes[1].getAttribute("label"),
            rTreeCh.childNodes[select[0]].childNodes[0].childNodes[2].getAttribute("label"),
            select[0]];
}